
#include <math.h>
#include <stdio.h>
#include <conio.h>

#include "PoseDetermination.h"


const unsigned N=5;

int main()
{
	CPoseDetermination::point3d SpacePointList[N];

// hardwire some known features.
	SpacePointList[0]=CPoseDetermination::point3d(0,0,10);
	SpacePointList[1]=CPoseDetermination::point3d(10,10,12);
	SpacePointList[2]=CPoseDetermination::point3d(-10,10,12);
	SpacePointList[3]=CPoseDetermination::point3d(10,-10,25);
	SpacePointList[4]=CPoseDetermination::point3d(150,60,40);


	CPoseDetermination::point3d UndistortedImagePointList[N];
	double f=20;

// projection on the image plane (undistorted parameters).
	for (unsigned i=0; i<N; i++)
		UndistortedImagePointList[i]=CPoseDetermination::point3d(f*SpacePointList[i].x/SpacePointList[i].z,f*SpacePointList[i].y/SpacePointList[i].z,f);


	double DistanceList[N];
	bool success=CPoseDetermination::findDistances(N,SpacePointList,UndistortedImagePointList,DistanceList);


	if (success)
	{
		printf("Successfull pose determination\n");

		for (unsigned k=0; k<N; k++)
		{
			CPoseDetermination::point3d p=SpacePointList[k];
			CPoseDetermination::point3d u=UndistortedImagePointList[k];
			double norm=sqrt(u.x*u.x+u.y*u.y+u.z*u.z);
			double ndist=DistanceList[k]/norm;

			CPoseDetermination::point3d rp(u.x*ndist,u.y*ndist,u.z*ndist);

			printf("Point p(%f,%f,%f) reconstructed at (%f,%f,%f)\n",p.x,p.y,p.z,rp.x,rp.y,rp.z);
		}
	}
	else
	{
		printf("Can not solve pose determination\n");
	}

	printf("Press any key...\n");
	getch();

	return 0;
}

